package com.stu.stusystem.service.system.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotEmpty;

/**
 * @author cxt
 * @date 2021/3/29
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class MenuDTO {
    private String id;

    @ApiModelProperty("图标")
    private String iconImg;

    @ApiModelProperty("名称")
    @NotEmpty(message = "名称不能为空")
    private String name;

    @ApiModelProperty("页面url")
    private String url;

    @ApiModelProperty("权限code")
    @NotEmpty(message = "权限code不能为空")
    private String code;

    @ApiModelProperty("父级id")
    private String pid;

    @ApiModelProperty("菜单类型(M:目录，C:菜单，B:按钮)")
    private String menuType;

    @ApiModelProperty("是否启用")
    private Boolean isVisible;

    @ApiModelProperty("排序")
    private Integer orderNum;
}
